open Namespace_symbols_util
open Xquery_common_ast

type atomic_letter_mapping =  (int ref) * int SQNameHashtbl.t

type cename_letter_mapping =  (int ref) * (Namespace_symbols.rtype_symbol option * nillable * int) SQNameHashtbl.t

type caname_letter_mapping =  (int ref) * (Namespace_symbols.rtype_symbol option * int) SQNameHashtbl.t

type letter_mappings = atomic_letter_mapping * cename_letter_mapping * caname_letter_mapping

let create_at_mapping () = (ref 0, SQNameHashtbl.create 7)
let create_ce_mapping () = (ref 0, SQNameHashtbl.create 7)
let create_ca_mapping () = (ref 0, SQNameHashtbl.create 7)
let create_letter_mappings () = 
  (create_at_mapping(), create_ce_mapping (), create_ca_mapping ())

let type_letter_map (tm,_,_) = tm
let elem_letter_map (_,em,_) = em
let attr_letter_map (_,_,am) = am

let copy_letter_mappings mappings = 
  let (tref, tm) = type_letter_map mappings in 
  let (eref, em) = elem_letter_map mappings in 
  let (aref, am) = attr_letter_map mappings in 
  ((ref (!tref), SQNameHashtbl.copy tm), (ref (!eref), SQNameHashtbl.copy em), ((ref !aref), SQNameHashtbl.copy am))


