(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: print_type_core.mli,v 1.3 2006/03/02 17:40:50 mff Exp $ *)

(* Module: Print_core_type
   Description:
     This module implements pretty-printing for the core variant of
     the XQuery type system.
*)

val print_celem_decl : Format.formatter -> Xquery_type_core_ast.celem_declaration -> unit
val print_cattr_decl : Format.formatter -> Xquery_type_core_ast.cattr_declaration -> unit
val print_ctype_decl : Format.formatter -> Xquery_type_core_ast.ctype_declaration -> unit

val print_cxtype     : Format.formatter -> Xquery_type_core_ast.cxtype -> unit

val print_cxschema   : Format.formatter -> Xquery_type_core_ast.cxschema -> unit
val print_letter_mappings  : Format.formatter -> Xquery_type_core_ast_annotation.letter_mappings -> unit

