(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                             XQuery Engine                           *)
(*                                                                     *)
(*  Copyright 2001-2004, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: galax_camomile.ml,v 1.4 2006/05/16 23:33:59 simeon Exp $ *)

(* Module: Glx_camomile
   Description:
     This module is a wrapper over Camomile operations.
*)

module TextUTF8 = Camomile.UNF.Make(Camomile.UTF8)

let nfc x = TextUTF8.nfc x
let nfd x = TextUTF8.nfd x
let nfkc x = TextUTF8.nfkc x
let nfkd x = TextUTF8.nfkd x

let utf8_string_of_code_point i =
  Encoding.character (Encoding.get_internal_encoding ()) i

let utf8_add_point_to_buffer b i =
  let c = Encoding.character (Encoding.get_internal_encoding ()) i in
  Buffer.add_string b c

let utf8_string_of_code_points c =
  let b = Buffer.create 10 in
  List.iter (utf8_add_point_to_buffer b) c;
  Buffer.contents b

let utf8_codepoint_compare s1 s2 =
  Camomile.UTF8.compare s1 s2

