(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2004, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: galax_http.mli,v 1.1 2006/01/17 23:03:03 simeon Exp $ *)

(* Module: Glx_http
   Description:
     This module contains some stuff used to hook up Galax to the http
     client provided by Trevor.
*)

type http_method =
  | File of string
  | Http of (string * int * string)
  | ExternalSource of (string * string * string option * string)

val register_method : string -> unit

val glx_decode_url : string -> http_method

val glx_http_get   : string -> int -> string -> string

val http_soap      : string -> string -> string -> string -> string

