(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                             XQuery Engine                           *)
(*                                                                     *)
(*  Copyright 2001-2004, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: register_handlers.mli,v 1.1 2005/08/05 00:15:02 chrisre Exp $ *)

(* Module: Register_handlers 

   Description: 

   This module handles registration of close handlers for Galax. These
   handlers allow persistant stores to do any final cleanup before
   exiting. 

   We could also allow things like failure handlers, sync handlers but
   right now we just have proper close handlers. 
*)

(* Close (end of run) handlers *)
val register_close_handler : (unit -> unit) -> unit
val call_close_handlers    : unit -> unit
