open Code_selection_context
open Execution_context
open Namespace_symbols
open Physical_value

val build_scalar_code :
    code_selection_context -> 
      Algebra_type.algop_expr -> 
	Xquery_common_ast.literal -> 
	  (Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val build_seq_code :
    code_selection_context -> 
      Algebra_type.algop_expr -> 
	(Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val build_empty_code :
    code_selection_context -> 
      Algebra_type.algop_expr -> 
	(Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val build_error_code :
    code_selection_context -> 
      Algebra_type.algop_expr -> 
	(Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val build_document_code :
    code_selection_context -> 
      Algebra_type.algop_expr -> 
	(Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val build_pi_code :
    code_selection_context -> 
      Algebra_type.algop_expr -> 
	(Namespace_names.ncname * string) ->
	  (Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val build_picomputed_code :
    code_selection_context -> 
      Algebra_type.algop_expr -> 
	(Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val build_comment_code :
    code_selection_context -> 
      Algebra_type.algop_expr -> 
	Datatypes.xs_untyped ->
	  (Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val build_commentcomputed_code :
    code_selection_context -> 
      Algebra_type.algop_expr -> 
	(Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val build_text_code :
    code_selection_context -> 
      Algebra_type.algop_expr -> 
	Datatypes.xs_untyped ->
	  (Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val build_textcomputed_code :
    code_selection_context ->
      Algebra_type.algop_expr -> 
	(Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val build_elem_code :
    code_selection_context -> 
      Algebra_type.algop_expr -> 
	(relem_symbol * Namespace_context.nsenv) ->
	(Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val build_anyelem_code :
    code_selection_context -> 
      Algebra_type.algop_expr -> 
	Namespace_context.nsenv ->
	(Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val build_attr_code :
    code_selection_context -> 
      Algebra_type.algop_expr -> 
	rattr_symbol ->
	(Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val build_anyattr_code :
    code_selection_context -> 
      Algebra_type.algop_expr -> 
	Namespace_context.nsenv ->
	(Algebra_type.alg_eval_code_dep  * Code_selection_context.code_selection_context)

val select_physical_op : 
  Code_selection_context.code_selection_context ->
    Algebra_type.algop_expr -> 
      Xquery_physical_algebra_ast.physop_expr_name
