open Cs_util_coercion
open Error
open Execution_context
open Physical_item
open Physical_value
open Xquery_algebra_ast
open Xquery_algebra_ast_util

(* CEKeyRef *)
let build_default_cekeyref_code code_ctxt kn =
  (fun alg_ctxt kv ->
    let keyval =
      try
	if (Cursor.cursor_is_empty kv)
	then 
	  ""
	else
	  let i = Physical_util.get_item kv in
	  match item_kind i with
	  | NodeKind -> (getNode i)#string_value()
	  | AtomicValueKind -> (getAtomicValue i)#erase_atomic_value()
      with
      | _ ->
	  raise (Query (Code_Selection "key definition: key value not an item"))
    in
    key_from_algebra_context alg_ctxt (kn,keyval)
  )

let build_keyref_code code_ctxt algop str =
  let _ = access_nosub algop.pdep_sub_expression in 
  let fn = build_default_cekeyref_code code_ctxt str in
  (coerce_nodep fn coerce_unary_item_cursor_to_item_list), code_ctxt

