(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2004, Lucent Technologies and AT&T Labs.            *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* Module: Code_sort_join
   Description:    
     Implements XQuery's sort joins algorithm.
*)

open Xquery_common_ast
open Algebra_type
open Code_selection_context

val build_sort_join :
    Code_util_join.outer_kind -> code_selection_context -> 
      Code_util_predicates.predicate_functions ->
	Xquery_algebra_ast.predicate_desc ->
	  alg_eval_code_dep  * code_selection_context

val build_sort_join_with_btree_index :
    Code_util_join.outer_kind -> code_selection_context -> Physical_name_index.name_index_handler ->
      Code_util_predicates.predicate_functions ->
	Xquery_algebra_ast.predicate_desc -> 
	  alg_eval_code_dep  * code_selection_context

