(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: cs_annotate.mli,v 1.3 2006/01/27 22:06:46 mff Exp $ *)

(* Module: Cs_annotate.
   Description:
     This module implements algebraic annotation for the physical layer.x.
*)

(* 
   Annotation is really a separate 'sub-phase', that deals with
   annotations needed for physical operators 
*)

val annotate_context   : Logical_algebra_types.logical_alg_compile_context -> Algebra_type.alg_compile_context

val annotate_statement : Algebra_type.alg_compile_context -> Logical_algebra_types.logical_algop_expr -> Algebra_type.algop_expr

val annotate_prolog : Logical_algebra_types.logical_alg_compile_context
  -> Logical_algebra_types.logical_algop_prolog ->
  Algebra_type.algop_prolog * Algebra_type.alg_compile_context


val annotate_prolog_with_bindings : Algebra_type.alg_compile_context   
  -> Logical_algebra_types.logical_algop_prolog ->
  Algebra_type.algop_prolog * Algebra_type.alg_compile_context

val annotate_module : Logical_algebra_types.logical_alg_compile_context
  -> Logical_algebra_types.logical_algop_xmodule ->
  Algebra_type.algop_xmodule * Algebra_type.alg_compile_context

val annotate_module_with_bindings : Algebra_type.alg_compile_context
  -> Logical_algebra_types.logical_algop_xmodule ->
  Algebra_type.algop_xmodule * Algebra_type.alg_compile_context

val make_temp_annotated_expr :
  Xquery_algebra_ast.algop_expr_name ->
    Algebra_type.algop_sub_exprs ->
      Algebra_type.algop_sub_exprs ->
	Finfo.finfo ->
	  Algebra_type.algop_expr
