(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: variable_context_manager.mli,v 1.3 2006/02/02 21:03:16 mff Exp $ *)

(* This module eals with variable contexts during runtime. 
   It also holds the build functions to access and store variables*)

type variable_context_manager
type variable_ref 

val build_context_manager : unit -> variable_context_manager
(* This must be called before the manager can be used - 
   it allocates space for the variables.
   
   After it is called no variable references can be added to the context manager
*)
val instantiate_variable_context_manager : variable_context_manager -> unit


val build_parameter_insert_code : variable_context_manager -> int -> (Physical_value.physical_value -> unit)

val build_variable_enter_context : variable_context_manager -> (unit -> unit)
val build_variable_exit_context  : variable_context_manager -> (unit -> unit)
val build_variable_store_code           : variable_ref -> (Physical_value.physical_value -> unit)
val build_variable_retrieve_code         : variable_ref -> (unit -> Physical_value.physical_value)

val get_new_variable_slot                : variable_context_manager -> variable_ref

val string_of_variable_ref      : variable_ref -> string
