/***********************************************************************/
/*                                                                     */
/*                                 GALAX                               */
/*                              XQuery Engine                          */
/*                                                                     */
/*  Copyright 2001-2003, Lucent Technologies.                          */
/*  Distributed only by permission.                                    */
/*                                                                     */
/***********************************************************************/

/* $Id: galax_types.h,v 1.5 2005/12/30 20:01:14 simeon Exp $ */

#include "itemlist.h"


/**********************/
/* Atomic value types */
/**********************/

typedef item atomicValue;
typedef item atomicString;
typedef item atomicBoolean;
typedef item atomicInteger;
typedef item atomicDecimal;
typedef item atomicFloat;
typedef item atomicDouble;
typedef item atomicAnyURI;
typedef item atomicUntyped;
typedef item atomicQName;
typedef item atomicDateTime;
typedef item atomicDate;
typedef item atomicTime;
typedef item atomicDayTimeDuration;
typedef item atomicYearMonthDuration;

/**************/
/* Node types */
/**************/

typedef item node;

typedef item document;
typedef item element;
typedef item text;
typedef item attribute;
typedef item comment;
typedef item processingInstruction;


/******************/
/* Sequence types */
/******************/

typedef itemlist atomicValue_list;
typedef itemlist attribute_list;
typedef itemlist node_list;


/*****************/
/* Context types */
/*****************/

typedef item processing_context;
typedef item external_context;
typedef item compiled_prolog;
typedef item compiled_statement;
typedef itemlist compiled_stmt_list; 
typedef item prepared_prolog;
typedef item namespace_env;

typedef struct compiled_module_struct {
  compiled_prolog compiled_prolog;
  compiled_stmt_list compiled_stmts;
} *compiled_module; 


