/***********************************************************************/
/*                                                                     */
/*                                 GALAX                               */
/*                              XQuery Engine                          */
/*                                                                     */
/*  Copyright 2001-2003, Lucent Technologies.                          */
/*  Distributed only by permission.                                    */
/*                                                                     */
/***********************************************************************/

/**
 * @(#)CompiledModule.java
 *
 */

package galapi;

/**
 *
 * A <code>CompiledModule</code> encapsulates a native 
 * compiled prolog and a list of statements to be
 * evaluated.
 *
 * @see CompiledProlog
 * @see ItemList
 */

public class CompiledModule extends Context
{
    protected CompiledModule() {}
    protected CompiledModule (int native_item) {
	setItem (native_item);
    }
    public CompiledProlog getCompiledProlog() { 
	int cp = nativeGetCompiledProlog(getNativeItem());
	return new CompiledProlog(cp);
    }
    public ItemList getCompiledStatements() { 
	int il = nativeGetCompiledStatements(getNativeItem());
	return new ItemList(il);
    }
    protected static native int nativeGetCompiledProlog (int cm);
    protected static native int nativeGetCompiledStatements (int cm);

}// class CompiledModule
