/***********************************************************************/
/*                                                                     */
/*                                 GALAX                               */
/*                              XQuery Engine                          */
/*                                                                     */
/*  Copyright 2001-2003, Lucent Technologies.                          */
/*  Distributed only by permission.                                    */
/*                                                                     */
/***********************************************************************/

/**
 * @(#)CompiledProlog.java
 *
 */

package galapi;

/**
 * The <code>CompiledProlog</code> encapsulates one or more prologs 
 * that have been compiled.  It includes:
 * </ul>
 * <li>the built-in types, namespaces, and functions
 * <li>the user-defined types, namespaces, and functions specified in
 *    any imported library modules
 * </ul>
 */

public class CompiledProlog extends Context
{
   
    protected CompiledProlog() {}

    protected CompiledProlog (int native_item) {
	setItem (native_item);
    }

    public NamespaceEnv nsenvFromCompiledProlog() {
	int i = nativeNsenvFromCompiledProlog(getNativeItem());

	return new NamespaceEnv (i);
	
    }

    /*
     * native methods
     *
     */
    protected static native int nativeNsenvFromCompiledProlog (int compiled_prolog);

}// class CompiledProlog
