/***********************************************************************/
/*                                                                     */
/*                                 GALAX                               */
/*                              XQuery Engine                          */
/*                                                                     */
/*  Copyright 2001-2003, Lucent Technologies.                          */
/*  Distributed only by permission.                                    */
/*                                                                     */
/***********************************************************************/

/**
 * @(#)PreparedProlog.java
 *
 */


package galapi;

/**
 * A <code>PreparedProlog</code> is a <code>CompiledProlog</code> takes 
 * an external context defined by the application (e.g., the values of
 * the context item and any global variables) and returns a prolog 
 * in which all global variables have been evaluated. 
 */

public class PreparedProlog extends CompiledProlog
{
   
    protected PreparedProlog() {}

    protected PreparedProlog (int native_item) {
	setItem (native_item);
    }

    public NamespaceEnv nsenvFromPreparedProlog() {
	int i = nativeNsenvFromPreparedProlog(getNativeItem());

	return new NamespaceEnv (i);
	
    }

    /*
     * native methods
     *
     */
    protected static native int nativeNsenvFromPreparedProlog (int prepared_prolog);

}// class PreparedProlog
