(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: pragma_lexer.mll,v 1.1 2005/04/13 16:35:36 simeon Exp $ *)

(* Module: Pragma_lexer
   Description:
     This module contains the part of the XQuery lexer corresponding
     to the PRAGMA lexical state.
*)

{

open Lexing

open Finfo
open Error

open Parse_xquery   (* tokens definition *)
open Lexing_util     (* lexical state handling *)

}

(****************)
(* Lexing rules *)
(****************)

rule token lh = parse
  | "#)"
      { let s = get_string lh in pop_state lh; push_default lh; (CLOSINGPRAGMA s) }
  | eof
      { raise (Query (Lexing(lexing_locinfo lexbuf, "Pragma not terminated"))) }
  | _
      { add_char_to_string lh (lexeme_char lexbuf 0); token lh lexbuf }

