(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: norm_expr.mli,v 1.3 2005/10/31 16:33:26 mff Exp $ *)

(* Module: Norm_expr
   Description:
     This module implements normalization for XQuery expressions.
*)

open Xquery_ast
open Xquery_core_ast

open Norm_context


(* Auxiliary normalization code, notablye used in normalization of updates *)

val normalize_fl_clauses      : norm_context -> expr -> fl_expr list -> acfl_expr list
val normalize_order_by_clause : norm_context -> order_by option -> Finfo.finfo -> acorder_by option

val normalize_expr_opt : norm_context -> expr option -> acexpr option

(* Normalization of expressions *)

val normalize_expr           : norm_context -> expr      -> acexpr

