(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: norm_ident_expr.mli,v 1.1 2005/02/04 15:48:17 simeon Exp $ *)

(* Module: Norm_ident_expr
   Description:
     This module implements a replacement for the normalization phase
     which does not actual normalize, but generates a core AST
     isomorphic to the original XQuery AST.
*)

open Xquery_ast
open Xquery_core_ast

open Norm_context


(* Auxiliary normalization code, notablye used in normalization of updates *)

val normalize_ident_fl_clauses      : norm_context -> fl_expr list -> acfl_expr list
val normalize_ident_order_by_clause : norm_context -> order_by option -> Finfo.finfo -> acorder_by option

val normalize_ident_expr_opt : norm_context -> expr option -> acexpr option

(* Normalization of expressions *)

val normalize_ident_expr           : norm_context -> expr      -> acexpr

