(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: norm_ident_top.mli,v 1.1 2005/02/04 15:48:18 simeon Exp $ *)

(* Module: Norm
   Description:
     This module implements XQuery normalization phase.
*)

open Xquery_ast
open Xquery_core_ast

open Norm_context


(* Normalization functions for:
     o individual statements
     o library module
     o main module 
*)

val normalize_ident_statement      :
    norm_context -> statement -> acstatement
val normalize_ident_prolog         :
    norm_context -> prolog -> (norm_context * acprolog)
val normalize_ident_library_module :
    norm_context -> library_module -> (norm_context * acxmodule)
val normalize_ident_main_module    :
    norm_context -> main_module -> (norm_context * acxmodule)

val normalize_ident_module         : norm_context -> xmodule -> (norm_context * acxmodule)

