(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: norm_top.mli,v 1.9 2005/01/28 17:50:08 simeon Exp $ *)

(* Module: Norm
   Description:
     This module implements XQuery normalization phase.
*)

open Xquery_ast
open Xquery_core_ast

open Norm_context


(* Normalization functions for:
     o individual statements
     o library module
     o main module 
*)

val normalize_statement      :
    norm_context -> statement -> acstatement
val normalize_prolog         :
    norm_context -> prolog -> (norm_context * acprolog)
val normalize_library_module :
    norm_context -> library_module -> (norm_context * acxmodule)
val normalize_main_module    :
    norm_context -> main_module -> (norm_context * acxmodule)

val normalize_module         : norm_context -> xmodule -> (norm_context * acxmodule)

(* Dummy functions used when normalization is disabled *)

val nonorm_statement      : norm_context -> statement -> acstatement
val nonorm_prolog         : norm_context -> prolog -> (norm_context * acprolog)
val nonorm_library_module : norm_context -> library_module -> (norm_context * acxmodule)
val nonorm_main_module    : norm_context -> main_module -> (norm_context * acxmodule)

