(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)


(* $Id: optimization_judge.mli,v 1.6 2006/02/01 08:24:13 pmichiel Exp $ *)

(* Module: Optimization judgements. Currently these all have to deal
   with side-effects. *)

open Xquery_common_ast

type ('a,'b) optimization_judge_env =  ('a,'b) Compile_context.compile_context

val has_non_trivial_snap     : ('a,'b) optimization_judge_env -> ('a, 'b) Xquery_algebra_ast.aalgop_expr  -> bool

val has_side_effect          : ('a,'b) optimization_judge_env -> ('a, 'b) Xquery_algebra_ast.aalgop_expr  -> bool

val is_dot_field             : crname -> bool

val is_seq_field             : crname -> bool

val is_singleton_tuple       : ('a,'b) optimization_judge_env -> ('a, 'b) Xquery_algebra_ast.aalgop_expr  -> bool

val is_recursive_function    : ('a,'b) optimization_judge_env -> Xquery_common_ast.cfname * int -> bool


(* returns
    - sequence field name
    - final output field name
*)
val is_sequence_to_field_mapping : ('a, 'b) Xquery_algebra_ast.aalgop_expr -> (crname * crname) option

(* returns
    - sequence field name
    - output field of tree pattern
    - treepattern operator
    - the mapconcat's indep operator
    (respectively)
*)
val is_step_to_sequence_mapping  : ('a, 'b) Xquery_algebra_ast.aalgop_expr -> 
                                   (crname * 
                                    crname *  
                                    ('a, 'b) Xquery_algebra_ast.aalgop_expr *
                                    ('a, 'b) Xquery_algebra_ast.aalgop_expr) option

val ord_dup_matters :('a, 'b) Xquery_algebra_ast.aalgop_expr  -> ('a, 'b) Xquery_algebra_ast.aalgop_expr -> bool

val contains_update : ('a, 'b) Xquery_algebra_ast.aalgop_expr -> bool
