(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: optimization_predicates.mli,v 1.5 2005/09/09 17:13:03 chrisre Exp $ *)

(* Module: Optimization_predicates
   Description:
     This module is used to process predicates during optimization.
*)

open Xquery_algebra_ast

val is_simple_conjunct         : Logical_algebra_types.logical_algop_expr -> bool

(* Get the predicate description from an op
   that has one *)
val extract_pred_desc          : Logical_algebra_types.logical_algop_expr -> predicate_desc

(* Construct a select *)
val construct_singleton_select : Logical_algebra_types.logical_algop_expr -> Logical_algebra_types.logical_algop_expr -> 
  Xquery_ast.expr_handle -> Finfo.finfo -> Logical_algebra_types.logical_algop_expr

val conjunctive_merge_select   :  Logical_algebra_types.logical_algop_expr -> Logical_algebra_types.logical_algop_expr -> Logical_algebra_types.logical_algop_expr 

(* Remove a conjunct from an op with a predicate
   If this conjunct is the only predicate in a select, return None
   else return Some op modified (Notice this should turn a Join into a product *)
val remove_conjunct            : Logical_algebra_types.logical_algop_expr -> int -> Logical_algebra_types.logical_algop_expr option


