(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)


(* Module: Optimization Rewrite SBDO
   Description:
     This module implements the SBDO optimization, described in

       Optimizing Sorting and Duplicate Elimination 
       in XQuery Path Expressions
       
       Mary Fernndez, Jan Hidders, Philippe Michiels, 
       Jrme Simon, Roel Vercammen
       
       DEXA 2005
       http://www.adrem.ua.ac.be/bibrem/pubs/fernandez.1.pdf
*)

val sbdo_rewrite : 
    ('a, 'b) Compile_context.compile_context ->
      ('c, 'd) Xquery_algebra_ast.aalgop_expr ->
	('c, 'd) Xquery_algebra_ast.aalgop_expr * bool
