(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: optimization_top.ml,v 1.6 2005/09/09 17:13:03 chrisre Exp $ *)

(* Module: Compilation_top
   Description:
     This module implements algebraic query optimization.
*)
(* Annotation is really a separate 'sub-phase' but is bundled here
   since it is on the boundary of two phases *)
open Processing_context
open Compile_context

open Xquery_algebra_ast
open Xquery_algebra_ast_util

open Optimization_rewrite

let optimize_statement comp_ctxt algop_expr = 
  rewrite_expression comp_ctxt algop_expr 
 

(* JEROME: Is there a reason we cannot optimize within the prolog? *)
let optimize_prolog comp_ctxt alg_prolog =    
    (comp_ctxt,alg_prolog)

let optimize_module comp_ctxt alg_module =
  let (alg_prolog,alg_statements) = split_main_module_plan alg_module in
  let opt_alg_statements = List.map (rewrite_expression comp_ctxt) alg_statements in
    comp_ctxt, (fmkalgop_xmodule alg_prolog opt_alg_statements)
    

let optimize_library_module comp_ctxt alg_module =
  optimize_module comp_ctxt alg_module 
    

let optimize_main_module    comp_ctxt alg_module =
  optimize_module comp_ctxt alg_module 
    


