(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: optimization_top.mli,v 1.6 2005/09/09 17:13:03 chrisre Exp $ *)

(* Module: Compilation_top
   Description:
     This module implements algebraic query optimization.
*)

val optimize_statement 	    : Logical_algebra_types.logical_alg_compile_context -> Logical_algebra_types.logical_algop_expr    -> Logical_algebra_types.logical_algop_expr

val optimize_prolog    	    : Logical_algebra_types.logical_alg_compile_context -> Logical_algebra_types.logical_algop_prolog  -> 
  Logical_algebra_types.logical_alg_compile_context * Logical_algebra_types.logical_algop_prolog

val optimize_library_module : Logical_algebra_types.logical_alg_compile_context -> Logical_algebra_types.logical_algop_xmodule -> 
  Logical_algebra_types.logical_alg_compile_context * Logical_algebra_types.logical_algop_xmodule

val optimize_main_module    : Logical_algebra_types.logical_alg_compile_context -> Logical_algebra_types.logical_algop_xmodule -> 
  Logical_algebra_types.logical_alg_compile_context * Logical_algebra_types.logical_algop_xmodule

