(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                            XML Query Engine                         *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: parse_context.mli,v 1.11 2006/01/17 23:03:03 simeon Exp $ *)

(* Module: Parse_context
   Description:
     This module implements the parsing context.
 *)

type parse_context

val build_xquery_parse_context :
    Processing_context.processing_context -> parse_context

val add_general_entity_to_parse_context :
    parse_context -> string -> string -> unit

val get_processing_context :
    parse_context -> Processing_context.processing_context

val get_general_entity :
    parse_context -> Finfo.finfo -> string -> string

val get_lexing_handler :
    parse_context -> Lexing_util.lexing_handler

