(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: parse_top.mli,v 1.5 2005/07/12 22:56:17 simeon Exp $ *)

(* Module: Parse_top
   Description:
     This module implements top-level parsing functions.
 *)


(*******************************)
(* Top-level parsing functions *)
(*******************************)

(* Statement *)

val parse_statement_from_io      : Parse_context.parse_context -> Galax_io.input_spec -> Xquery_ast.statement

(* Prolog *)

val parse_prolog_from_io         : Parse_context.parse_context -> Galax_io.input_spec -> Parse_context.parse_context * Xquery_ast.prolog

(* Library module *)

val parse_library_module_from_io : Parse_context.parse_context -> Galax_io.input_spec -> Parse_context.parse_context * Xquery_ast.library_module

(* Main module *)

val parse_main_module_from_io	 : Parse_context.parse_context -> Galax_io.input_spec -> Parse_context.parse_context * Xquery_ast.main_module


(* Content models *)

val parse_type_from_io : Parse_context.parse_context -> Galax_io.input_spec -> Xquery_type_ast.xtype option * Xquery_type_ast.xtype

