(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2004, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: physical_xml_value.mli,v 1.4 2006/02/02 21:03:17 mff Exp $ *)

(* Module: Physical_xml_value
   Description:
     This modules defines physical representations of XML values.
*)

open Physical_value

(* Conversions *)

val dom_value_of_sax_value : sax_value -> dom_value
val sax_value_of_dom_value : dom_value -> sax_value

val materialize_xml_value  : xml_value -> xml_value

val dom_value_of_xml_value : xml_value -> dom_value
val sax_value_of_xml_value : xml_value -> sax_value

val xml_value_of_dom_value : dom_value -> xml_value
val xml_value_of_sax_value : sax_value -> xml_value

val is_empty_xml_value : xml_value -> bool

