(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: planio_parse_plan_xml.mli,v 1.3 2006/03/24 19:01:47 mff Exp $ *)

(* Module Planio_parse_plan_xml
   Description:
   This module parses the algebraic plans which are serialized by algebra_print_xml.ml
   so that they may be run again after modification

   NOTE: This code is not currently hooked into the runtime.
*)

open Xquery_algebra_ast
(*
val parse_module_logical_plan_from_xml_stream: 
  Sax_types.resolved_sax_event Stream.t -> ('a option, unit, 'b option) Xquery_algebra_ast.aalgop_xmodule 

val parse_expression_logical_plan_from_xml_stream: 
  Sax_types.resolved_sax_event Stream.t -> ('a option, unit) Xquery_algebra_ast.aalgop_expr
*)

  
val parse_serialized_module_plan:
  Processing_context.processing_context -> Logical_algebra_types.logical_alg_compile_context -> Galax_io.input_spec ->
  Logical_algebra_types.logical_algop_xmodule * Logical_algebra_types.logical_alg_compile_context

val parse_serialized_expression_plan:
  Processing_context.processing_context -> Logical_algebra_types.logical_alg_compile_context -> Galax_io.input_spec ->
  Logical_algebra_types.logical_algop_expr 
