(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2004, Lucent Technologies and AT&T Labs.            *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* Module: Algebgra_print_utils
   Description:
   This module contains some util functions for algebra printers and parsers

*)

val xml_string_of_prefix: Namespace_names.prefix -> string
val xml_prefix_of_string: string -> Namespace_names.prefix

val optint_of_string: string -> int option
val string_of_optint: int option -> string

val string_of_sortkind: Xquery_common_ast.sortkind -> string
val sortkind_of_string: string -> Xquery_common_ast.sortkind

val string_of_stablekind: Xquery_common_ast.stablekind -> string
val stablekind_of_string: string -> Xquery_common_ast.stablekind

val string_of_emptysortkind: Xquery_common_ast.emptysortkind -> string
val emptysortkind_of_string: string -> Xquery_common_ast.emptysortkind

val axis_of_string:  string -> Xquery_common_ast.axis

val string_of_physical_type: Xquery_physical_type_ast.physical_type -> string
val physical_type_of_string: string -> Xquery_physical_type_ast.physical_type 

val get_cardinality: string -> int

val get_subexpr_arity: ('a, 'b) Xquery_algebra_ast.aalgop_sub_exprs -> int
val get_subexpr_type : ('a, 'b) Xquery_algebra_ast.aalgop_sub_exprs -> string

val atomic_type_of_string: string -> Datatypes.atomic_type

