(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2004, Lucent Technologies and AT&T Labs.            *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* Module: Algebgra_print_xml
   Description:
    This module prints serializes undecorated algebraic to XML
*)

val serialize_logical_algebra_statement : Processing_context.processing_context -> Galax_io.output_spec 
  -> ('a,'b) Xquery_algebra_ast.aalgop_expr
  -> unit

val serialize_logical_algebra_module    : Processing_context.processing_context -> Galax_io.output_spec 
  -> ('a, 'b, 'c) Xquery_algebra_ast.aalgop_xmodule 
  -> unit


val serialize_physical_algebra_statement : Processing_context.processing_context -> Galax_io.output_spec 
  -> Algebra_type.algop_expr
  -> unit

val serialize_physical_algebra_module    : Processing_context.processing_context -> Galax_io.output_spec 
  -> Algebra_type.algop_xmodule 
  -> unit

val xml_stream_of_logical_plan_expr  : 
  Namespace_context.nsenv -> ('a,'b) Xquery_algebra_ast.aalgop_expr -> 
  Streaming_types.resolved_xml_stream


val xml_stream_of_logical_plan_prolog : 
  Namespace_context.nsenv -> ('a,'b, 'c) Xquery_algebra_ast.aalgop_prolog -> 
  Streaming_types.resolved_xml_stream

val xml_stream_of_logical_plan_module : 
  Namespace_context.nsenv -> ('a,'b, 'c) Xquery_algebra_ast.aalgop_xmodule -> 
  Streaming_types.resolved_xml_stream


val xml_stream_of_physical_plan_expr  : 
  Namespace_context.nsenv -> Algebra_type.algop_expr -> 
  Streaming_types.resolved_xml_stream

val xml_stream_of_physical_plan_module : 
  Namespace_context.nsenv -> Algebra_type.algop_xmodule -> 
  Streaming_types.resolved_xml_stream


