(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2004, Lucent Technologies and AT&T Labs.            *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* Module: Algebra_print_xml_util
   Description:
   This module contains some util functions for algebra printers and
   parsers
*)

val construct_element      : Namespace_names.rqname -> Small_stream_ast.rsattribute_forest -> Small_stream_ast.rsexpr list
 -> Small_stream_ast.rsexpr 

val construct_attribute    : Namespace_names.rqname -> string -> Small_stream_ast.rsattribute 

val construct_comment      : string -> string -> Small_stream_ast.rsexpr list 

val attribute_of_occurrence: (Occurrence.occurs * Occurrence.occurs) option ->  Small_stream_ast.rsattribute

val element_of_rtype_symbol: Namespace_symbols.rtype_symbol -> Small_stream_ast.rsexpr
val element_of_relem_symbol: Namespace_symbols.relem_symbol -> Small_stream_ast.rsexpr
val element_of_rattr_symbol: Namespace_symbols.rattr_symbol -> Small_stream_ast.rsexpr

val element_of_kind_test     : Xquery_algebra_ast.akind_test -> Small_stream_ast.rsexpr
val element_of_aitemtype     : Xquery_algebra_ast.aitemtype -> Small_stream_ast.rsexpr

val element_of_asequencetype : Xquery_algebra_ast.asequencetype -> Small_stream_ast.rsexpr
val element_of_optasequencetype : Xquery_algebra_ast.asequencetype option -> Small_stream_ast.rsexpr list

