(* Path analysis for document projection
   over the XQuery algebra.

    - Michael *)


open Alg_path_struct


(* returned paths of an expression, returned paths contained in tuple fields, used paths of an expression *)
type paths = rooted_path_sequence * (Xquery_common_ast.crname * rooted_path_sequence) list * rooted_path_sequence

type analysis_context


val build_analysis_context :
  unit -> analysis_context

val add_var_paths :
  analysis_context -> Xquery_common_ast.cvname -> rooted_path_sequence -> analysis_context
  
val get_var_paths :
  analysis_context -> Xquery_common_ast.cvname -> rooted_path_sequence

(* Mirrors the implicit input tuple for algebra operations *)
val set_input_tuple_paths :
  analysis_context -> (Xquery_common_ast.cvname * rooted_path_sequence) list -> analysis_context
  
val get_input_tuple_paths :
  analysis_context -> (Xquery_common_ast.cvname * rooted_path_sequence) list
