(* Path analysis over the XQuery algebra. Intended for use
   with document projection and streaming. - Michael *)

open Alg_path_struct
open Alg_analysis_context


(*****************)
(* Path analysis *)
(*****************)

val path_analysis_of_logical_algop_expr :
  Logical_algebra_types.logical_algop_expr -> unit

val path_analysis_of_logical_algop_prolog :
  Logical_algebra_types.logical_algop_prolog  -> unit

val path_analysis_of_logical_algop_xmodule :
  Logical_algebra_types.logical_algop_xmodule  -> unit

(* This function is used in a hackish way by Galax-project.
   It should be removed. - Michael *)
val path_analysis_of_statement :
  Procmod_compiler.compiled_statement -> rooted_path_sequence


(**************************)
(* Streamability analysis *)
(**************************)

val is_streaming_prohibitive :
  rooted_path_sequence -> bool


(************)
(* Printing *)
(************)

val print_full_analysis :
  Format.formatter -> rooted_path_sequence -> unit

