(* Path analysis for document projection
   over the XQuery algebra.

   Essentially the same data structures as for path analysis
   over the XQuery core; just changed a cnode_test into
   anode_test, and added path_annotation.

    - Michael *)


open Xquery_common_ast
open Xquery_algebra_ast


(* A path is a sequence of steps (axis, nodetest pair). *) 

type path = (axis * anode_test) list

(* Source id *)

type source_id =
  | Document_id of string
  | Constructor_id of int

(* Subtree flag *)

type subtree =
  | Subtree
  | NoSubtree

(* Path fragments *)

type path_fragment = path * subtree

type path_fragment_sequence = path_fragment list

(* Rooted paths *)

type rooted_path = source_id * path_fragment

type rooted_path_sequence = rooted_path list

(* Path annotation *)

type path_annotation = rooted_path_sequence option ref
