(* Path analysis for document projection
   over the XQuery algebra.

    - Michael *)


open Alg_path_struct


(* Type for actions resulting from path navigation *)

type action =
  | GetSubtree
  | PreserveNode
  | SkipNode
  | KeepMovingPreserveNode of path_fragment_sequence
  | KeepMovingSkipNode of path_fragment_sequence


val mk_rooted_path_sequence_constructor : int -> rooted_path_sequence
val mk_rooted_path_sequence_document : string -> rooted_path_sequence

(* Turns all subtree annotations on *)
val imposes_subtree : rooted_path_sequence -> rooted_path_sequence

(* Printing of path structures *)
val print_path_sequence :
    Format.formatter -> rooted_path_sequence -> unit

(* step inside a document *)

val inside_document :
    Streaming_types.typed_annotated_sax_event -> rooted_path_sequence -> string -> path_fragment_sequence

(* step inside an external variable *)

(*
val inside_variable :
    Streaming_types.resolved_sax_event -> rooted_path_sequence -> Xquery_common_ast.cvname -> path_fragment_sequence
*)

(* step inside an element *)

val one_step :
    Streaming_types.typed_annotated_sax_event -> path_fragment_sequence -> action

(* step inside attributes *)

val one_step_attribute :
    path_fragment_sequence -> Streaming_types.typed_sax_xml_attribute -> bool
