(******************************************************************************)
(*                                                                            *)
(*                                 GALAX                                      *)
(*                              XQuery Engine                                 *)
(*                                                                            *)
(*  Copyright 2001-2003, Lucent Technologies.                                 *)
(*  Distributed only by permission.                                           *)
(*                                                                            *)
(******************************************************************************)

(* $Id: rewriting_ddo_annot.mli,v 1.1 2005/04/14 16:41:07 simeon Exp $ *)

(* Module: Rewriting_ddo_annot
     Description: This module implements detection and removal of
     unnecessary distinct-docorder operation from the query plan.
*)

open Error

open Xquery_core_ast
open Xquery_core_ast_util
open Xquery_core_ast_annotation

open Ast_walker_rewrite
open Processing_context

open Rewriting_ddo_automaton
open Rewriting_ddo_util

val start_new_automaton : Typing_context.static_context Ast_walker_rewrite_context.rewrite_context -> sbdo_kind -> st -> acexpr -> unit 
val annot_ast     : Typing_context.static_context Ast_walker_rewrite_context.rewrite_context -> sbdo_kind -> acexpr -> acexpr
val annot_vardecl : Typing_context.static_context Ast_walker_rewrite_context.rewrite_context -> sbdo_kind -> acvar_decl -> 
  (Typing_context.static_context Ast_walker_rewrite_context.rewrite_context * acvar_decl)

val hasMaxOne : acexpr -> bool

