(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2004, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: rewriting_ddo_util.mli,v 1.1 2005/04/14 16:41:08 simeon Exp $ *)

(* Module: Rewriting_ddo_util
   Description:
     This module implements utilities used during DDO rewriting.
*)

open Namespace_names

open Rewriting_ddo_automaton
open Processing_context

type st = ((prefix * uri * string), state) Hashtbl.t

val create_symbol_table : unit -> ((prefix * uri * string), state) Hashtbl.t
val register_var : ((prefix * uri * string), state) Hashtbl.t -> (prefix * uri * string) -> state -> unit
val unregister_var : ('a, 'b) Hashtbl.t -> 'a -> unit
val get_state : sbdo_kind -> ((prefix * uri * string), state) Hashtbl.t -> (prefix * uri * string) -> state

