(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: rewriting_judgments.mli,v 1.1 2005/04/14 16:41:08 simeon Exp $ *)

(* Module: Rewriting_judgments
   Description:
     This module implements some auxiliary judgments used within
     rewriting rules.
*)

val used_count : Xquery_common_ast.cvname -> Xquery_core_ast.acexpr -> int
    (* [used_count] determines the occurrence of variable $x in a
       given core expression *)

val can_fail : Typing_context.static_context -> Xquery_core_ast.acexpr -> bool
    (* [can_fail] determines whether the given core expression can
       raise an error *)

(*
val is_ordered : Xquery_ast.acexpr -> bool
    (* [is_ordered] determines whether the given core expression is
       already sorted by document order or not *)
*)

val does_node_care_about_order : Xquery_core_ast.acexpr -> bool
    (* [is_ordered] determines whether the semantics of the expression
       depends on document order or not. *)

