(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                              XQuery Engine                          *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: rewriting_rules_notyping.mli,v 1.4 2005/11/10 22:07:25 mff Exp $ *)

(* Module: Rewriting_rules_notyping
   Description:
     This module contains the rewriting rules that are independant of
     typing information.
*)

(**************************************************************************)
(* Various sets of rewriting rules : Rules are composed in procmod_phases *)
(**************************************************************************)

(* Generic rewriting rules that are independent of other optimization & typing options *)
val generic_rule_set    : Typing_context.static_context Ast_walker_rewrite_context.rewrite_rule_set

type clause_rewriter =
  Typing_context.static_context Ast_walker_rewrite_context.rewrite_context ->
  Xquery_core_ast.acfl_expr list ->
  Xquery_core_ast.acfl_expr ->
  Xquery_core_ast.acexpr ->
  Xquery_core_ast.acfl_expr list * Xquery_core_ast.acexpr * bool

(* A generic function for rewriting FLWOR clauses.  Takes one list of clause_rewriters for LET and one for FOR. *)
val flwr_rewrite :  clause_rewriter -> clause_rewriter -> 
  Typing_context.static_context Ast_walker_rewrite_context.rewrite_context ->
  Xquery_core_ast.acexpr -> Xquery_core_ast.acexpr * bool

val call_rewrite :
  Xquery_common_ast.cfname * int *
  (Typing_context.static_context Ast_walker_rewrite_context.rewrite_context -> Xquery_core_ast.acexpr -> Xquery_core_ast.acexpr list -> (Xquery_core_ast.acexpr * bool)) ->
  Typing_context.static_context Ast_walker_rewrite_context.rewrite_context -> Xquery_core_ast.acexpr -> (Xquery_core_ast.acexpr * bool)
