(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                            XML Query Engine                         *)
(*                                                                     *)
(*  Copyright 2001-2003, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: schema_simplification.mli,v 1.2 2004/08/25 15:41:57 simeon Exp $ *)

(* Module: Schema_simplification
   Description:
     This modules implements simplification rewritings over
     type. Those rewritings preserve the semantics of the type, but
     result in simpler, more readable types.
 *)

open Xquery_type_core_ast

val simplify_one_ty : cxschema -> cxtype -> cxtype * bool
val simplify_ty     : cxschema -> cxtype -> cxtype

