(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                            XML Query Engine                         *)
(*                                                                     *)
(*  Copyright 2001-2004, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: streaming_constructors.mli,v 1.6 2006/01/23 19:22:45 simeon Exp $ *)

(* Module: Stream_constructors
   Description:
     Construction operations over XML streams.
*)

open Finfo

open Streaming_types


(***********************)
(* Stream constructors *)
(***********************)

val text_constructor      : typed_xml_stream -> typed_xml_stream
val pi_constructor        : bool -> Namespace_names.ncname -> typed_xml_stream -> typed_xml_stream
val comment_constructor   : typed_xml_stream -> typed_xml_stream
val attribute_constructor : Namespace_symbols.rattr_symbol -> typed_xml_stream -> typed_xml_stream
val element_constructor   : Dm_atomic.atomicAnyURI option ref -> Namespace_symbols.relem_symbol -> Namespace_context.nsenv -> typed_xml_stream -> typed_xml_stream
val document_constructor  : Dm_atomic.atomicAnyURI option ref -> typed_xml_stream -> typed_xml_stream


(****************************)
(* Serialization operations *)
(****************************)

val glx_result_serialization : typed_xml_stream -> typed_xml_stream

val sequence_normalization : typed_xml_stream -> typed_xml_stream

