(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                            XML Query Engine                         *)
(*                                                                     *)
(*  Copyright 2001-2004, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: streaming_diff.mli,v 1.2 2005/07/11 19:29:52 simeon Exp $ *)

(* Module: Stream_diff
   Description:
     Compares two XML streams
*)

open Streaming_types


(***************)
(* Stream diff *)
(***************)

(* Return the first stream up to the point where it differs with the
   second stream, in which case it raises an error *)


val stream_diff : typed_xml_stream -> typed_xml_stream -> typed_xml_stream

(* Same, but just returns true or false *)

val stream_boolean_diff : typed_xml_stream -> typed_xml_stream -> bool

