(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                            XML Query Engine                         *)
(*                                                                     *)
(*  Copyright 2001-2004, Lucent Technologies.                          *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: streaming_parse.mli,v 1.3 2006/05/08 12:09:39 simeon Exp $ *)

(* Module: Parse_xml
   Description:
     This module implements a SAX parser for Galax.
*)

val glx_normalized_public_id : string -> string


(* Creates an XML stream from a string URI buffer and if a DTD exists
  and was parsed successfully, returns the XQuery type representing
  that DTD and the corresponding XML stream *)


val open_pxp_stream_from_io :
    Galax_io.input_spec -> Galax_io.pxp_stream * string option

val open_xml_stream_from_pxp_stream : Galax_io.pxp_stream * string option -> (Pxp_dtd.dtd option * Streaming_types.xml_stream)

val open_xml_stream_from_io : Galax_io.input_spec -> (Pxp_dtd.dtd option * Streaming_types.xml_stream)

val parse_standalone_dtd : Galax_io.input_spec -> Pxp_dtd.dtd

